;===========================================================================================
; directxproc.asm   AsmGges France  http://www.chez.com/asmgges/
;===========================================================================================

;===========================================================================================
; Cration d'une surface
;-------------------------------------------------------------------------------------------
; @AdrSurface = adresse de la variable qui va contenir l'adresse de la surface cre
; @LSurface   = largeur de la surface en pixels
; @HSurface   = hauteur de la surface en pixels
;===========================================================================================
CreateSurf frame @AdrSurface, @LSurface, @HSurface

    invoke ZeroMemory,addr ddsd,sizeof DDSURFACEDESC
    mov D[ddsd.dwSize],sizeof DDSURFACEDESC
    mov D[ddsd.dwFlags],DDSD_CAPS+DDSD_WIDTH+DDSD_HEIGHT
    mov D[ddsd.ddsCaps.dwCaps],DDSCAPS_OFFSCREENPLAIN
    mov eax,[@LSurface]
    mov [ddsd.dwWidth],eax
    mov eax,[@HSurface]
    mov [ddsd.dwHeight],eax
    dd_createsurface([DDraw],addr ddsd,[@AdrSurface],0)

    ret
endf
;===========================================================================================
; Remplir une surface avec une couleur
;-------------------------------------------------------------------------------------------
; @Surface = [Nom] Surface  remplir
; @Color   = couleur de remplissage format RGB 000000h
;===========================================================================================
FillSurface frame @Surface, @Color

    invoke ZeroMemory,addr ddbltfx,sizeof DDBLTFX
    mov D[ddbltfx.dwSize],sizeof DDBLTFX
    mov eax,[@Color]
    mov [ddbltfx.dwFillColor],eax
    dds_blt([@Surface],0,0,0,DDBLT_COLORFILL+DDBLT_WAIT,addr ddbltfx)

    ret
endf
;===========================================================================================
; Flip surface Back => surface Primary (Window Mode)
;===========================================================================================
FlipBackWinMode:
    invoke GetWindowRect,[hWin],addr rect2

    mov D[rect1.left],0
    mov D[rect1.top],0
    mov D[rect1.right],WSCREEN
    mov D[rect1.bottom],HSCREEN

    mov eax,[rect2.left]
    add eax,WSCREEN
    mov [rect2.right],eax

    mov eax,[rect2.top]
    add eax,[HBarTitle]
    mov [rect2.top],eax

    add eax,HSCREEN
    mov [rect2.bottom],eax
    dds_blt([Primary],addr rect2,[Back],addr rect1,DDBLT_WAIT,0)

    ret
;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================
