;===========================================================================================
; gddraw.inc GoAsm DirectX DDraw access AsmGges France  http://www.chez.com/asmgges/
;===========================================================================================

;DirectDraw
 DD_QueryInterface          = 000h
 DD_AddRef                  = 004h
 DD_Release                 = 008h
 DD_Compact                 = 00Ch
 DD_CreateClipper           = 010h
 DD_CreatePalette           = 014h
 DD_CreateSurface           = 018h
 DD_DuplicateSurface        = 01Ch
 DD_EnumDisplayModes        = 020h
 DD_EnumSurfaces            = 024h
 DD_FlipToGDISurface        = 028h
 DD_GetCaps                 = 02Ch
 DD_GetDisplayMode          = 030h
 DD_GetFourCCCodes          = 034h
 DD_GetGDISurface           = 038h
 DD_GetMonitorFrequency     = 03Ch
 DD_GetScanLine             = 040h
 DD_GetVerticalBlankStatus  = 044h
 DD_Initialize              = 048h
 DD_RestoreDisplayMode      = 04Ch
 DD_SetCooperativeLevel     = 050h
 DD_SetDisplayMode          = 054h
 DD_WaitForVerticalBlank    = 058h
 DD_GetAvailableVidMem      = 05Ch
 DD_GetSurfaceFromDC        = 060h
 DD_RestoreAllSurfaces      = 064h
 DD_TestCooperativeLevel    = 068h
 DD_GetDeviceIdentifier     = 06Ch
 DD_StartModeTest           = 070h
 DD_EvaluateMode            = 074h

;DirectDrawSurface
 DDS_QueryInterface         = 000h
 DDS_AddRef                 = 004h
 DDS_Release                = 008h
 DDS_AddAttachedSurface     = 00Ch
 DDS_AddOverlayDirtyRect    = 010h
 DDS_Blt                    = 014h
 DDS_BltBatch               = 018h
 DDS_BltFast                = 01Ch
 DDS_DeleteAttachedSurface  = 020h
 DDS_EnumAttachedSurfaces   = 024h
 DDS_EnumOverlayZOrders     = 028h
 DDS_Flip                   = 02Ch
 DDS_GetAttachedSurface     = 030h
 DDS_GetBltStatus           = 034h
 DDS_GetCaps                = 038h
 DDS_GetClipper             = 03Ch
 DDS_GetColorKey            = 040h
 DDS_GetDC                  = 044h
 DDS_GetFlipStatus          = 048h
 DDS_GetOverlayPosition     = 04Ch
 DDS_GetPalette             = 050h
 DDS_GetPixelFormat         = 054h
 DDS_GetSurfaceDesc         = 058h
 DDS_Initialize             = 05Ch
 DDS_IsLost                 = 060h
 DDS_Lock                   = 064h
 DDS_ReleaseDC              = 068h
 DDS_Restore                = 06Ch
 DDS_SetClipper             = 070h
 DDS_SetColorKey            = 074h
 DDS_SetOverlayPosition     = 078h
 DDS_SetPalette             = 07Ch
 DDS_Unlock                 = 080h
 DDS_UpdateOverlay          = 084h
 DDS_UpdateOverlayDisplay   = 088h
 DDS_UpdateOverlayZOrder    = 08Ch
 DDS_GetDDInterface         = 090h
 DDS_PageLock               = 094h
 DDS_PageUnlock             = 098h
 DDS_SetSurfaceDesc         = 09Ch
 DDS_SetPrivateData         = 0A0h
 DDS_GetPrivateData         = 0A4h
 DDS_FreePrivateData        = 0A8h
 DDS_GetUniquenessValue     = 0ACh
 DDS_ChangeUniquenessValue  = 0B0h
 DDS_SetPriority            = 0B4h
 DDS_GetPriority            = 0B8h
 DDS_SetLOD                 = 0BCh
 DDS_GetLOD                 = 0C0h

;DirectDrawClipper
 DDC_QueryInterface         = 000h
 DDC_AddRef                 = 004h
 DDC_Release                = 008h
 DDC_GetClipList            = 00Ch
 DDC_GetHWnd                = 010h
 DDC_Initialize             = 014h
 DDC_IsClipListChanged      = 018h
 DDC_SetClipList            = 01Ch
 DDC_SetHWnd                = 020h

;DirectDrawPalette
 DDP_QueryInterface         = 000h
 DDP_AddRef                 = 004h
 DDP_Release                = 008h
 DDP_GetCaps                = 00Ch
 DDP_GetEntries             = 010h
 DDP_Initialize             = 014h
 DDP_SetEntries             = 018h

;DirectDrawColorControl
 DDCC_QueryInterface        = 000h
 DDCC_AddRef                = 004h
 DDCC_Release               = 008h
 DDCC_GetColorControls      = 00Ch
 DDCC_SetColorControls      = 010h

;DirectDrawGammaControl
 DDGC_QueryInterface        = 000h
 DDGC_AddRef                = 004h
 DDGC_Release               = 008h
 DDGC_GetGammaRamp          = 00Ch
 DDGC_SetGammaRamp          = 010h

;structures
DDCOLORKEY struct
  dwColorSpaceLowValue     dd
  dwColorSpaceHighValue    dd
ends

DDPIXELFORMAT struct
  dwSize                   dd 
  dwFlags                  dd 
  dwFourCC                 dd 
union
  dwRGBBitCount            dd 
  dwYUVBitCount            dd 
  dwZBufferBitDepth        dd 
  dwAlphaBitDepth          dd 
  dwLuminanceBitCount      dd 
  dwBumpBitCount           dd 
ends
union
  dwRBitMask               dd 
  dwYBitMask               dd 
  dwStencilBitDepth        dd 
  dwLuminanceBitMask       dd 
  dwBumpDuBitMask          dd 
ends
union
  dwGBitMask               dd 
  dwUBitMask               dd 
  dwZBitMask               dd 
  dwBumpDvBitMask          dd 
ends
union
  dwBBitMask               dd 
  dwVBitMask               dd 
  dwStencilBitMask         dd 
  dwBumpLuminanceBitMask   dd 
ends
union
  dwRGBAlphaBitMask        dd 
  dwYUVAlphaBitMask        dd 
  dwLuminanceAlphaBitMask  dd 
  dwRGBZBitMask            dd 
  dwYUVZBitMask            dd 
ends
ends

DDSCAPS struct
  dwCaps                   dd 
ends

DDSURFACEDESC struct
  dwSize                   dd 
  dwFlags                  dd 
  dwHeight                 dd 
  dwWidth                  dd 
union
  lPitch                   dd 
  dwLinearSize             dd 
ends
  dwBackBufferCount        dd 
union
  dwMipMapCount            dd 
  dwZBufferBitDepth        dd 
  dwRefreshRate            dd 
ends
  dwAlphaBitDepth          dd 
  dwReserved               dd 
  lpSurface                dd 
  ddckCKDestOverlay        DDCOLORKEY
  ddckCKDestBlt            DDCOLORKEY
  ddckCKSrcOverlay         DDCOLORKEY
  ddckCKSrcBlt             DDCOLORKEY
  ddpfPixelFormat          DDPIXELFORMAT
  ddsCaps                  DDSCAPS
ends

DDBLTFX struct
  dwSize                   dd 
  dwDDFX                   dd 
  dwROP                    dd 
  dwDDROP                  dd 
  dwRotationAngle          dd 
  dwZBufferOpCode          dd 
  dwZBufferLow             dd 
  dwZBufferHigh            dd 
  dwZBufferBaseDest        dd 
  dwZDestConstBitDepth     dd 
union
  dwZDestConst             dd 
  lpDDSZBufferDest         dd 
ends
  dwZSrcConstBitDepth      dd 
union
  dwZSrcConst              dd 
  lpDDSZBufferSrc          dd 
ends
  dwAlphaEdgeBlendBitDepth dd 
  dwAlphaEdgeBlend         dd 
  dwReserved               dd 
  dwAlphaDestConstBitDepth dd 
union
  dwAlphaDestConst         dd 
  lpDDSAlphaDest           dd 
ends
  dwAlphaSrcConstBitDepth  dd 
union
  dwAlphaSrcCont           dd 
  lpDDSAlphaSrc            dd 
ends
union
  dwFillColor              dd 
  dwFillDepth              dd 
  dwFillPixel              dd 
  lpDDSPattern             dd 
ends
  ddckDestColorKey         DDCOLORKEY
  ddckSrcColorKey          DDCOLORKEY
ends

BITMAP struct
  bmType       dd 
  bmWidth      dd 
  bmHeight     dd 
  bmWidthBytes dd 
  bmPlanes     dw 
  bmBitsPixel  dw 
  bmBits       dd 
ends

OPEN_MCI struct
  dwCallback       dd 
  wDeviceID        dd 
  lpstrDeviceType  dd 
  lpstrElementName dd 
  lpstrAlias       dd 
ends

GENERIC_CALLBACK struct
  dwCallback       dd 
ends

PLAY_MCI struct
  dwCallback       dd 
  dwFrom           dd 
  dwTo             dd 
ends

;Equates
 DDSCL_EXCLUSIVE           = 010h
 DDSCL_FULLSCREEN          = 01h
 DDSCL_NORMAL              = 08h

 DDSD_CAPS                 = 01h
 DDSD_BACKBUFFERCOUNT      = 020h
 DDSD_PITCH                = 08h
 DDSD_HEIGHT               = 02h
 DDSD_WIDTH                = 04h

 DDSCAPS_BACKBUFFER        = 04h
 DDSCAPS_FRONTBUFFER       = 020h
 DDSCAPS_OFFSCREENPLAIN    = 040h
 DDSCAPS_SYSTEMMEMORY      = 0800h
 DDSCAPS_PRIMARYSURFACE    = 0200h
 DDSCAPS_FLIP              = 010h
 DDSCAPS_COMPLEX           = 08h
 DDPCAPS_8BIT              = 04h
 DDPCAPS_ALLOW256          = 040h

 DDBLT_COLORFILL           = 0400h
 DDBLT_DDFX                = 0800h
 DDBLT_WAIT                = 01000000h
 DDBLT_KEYSRC              = 08000h

 DDLOCK_SURFACEMEMORYPTR   = 0h
 DDLOCK_WAIT               = 01h

 DDWAITVB_BLOCKBEGIN       = 01h

 DDFLIP_WAIT               = 01h

 DDBLTFAST_NOCOLORKEY      = 00h
 DDBLTFAST_SRCCOLORKEY     = 01h
 DDBLTFAST_WAIT            = 010h

 DDCKEY_SRCBLT             = 08h

 DDERR_SURFACELOST         = 0887601C2h
 DDERR_WASSTILLDRAWING     = 08876021Ch

;===========================================================================================
;macros for access to ddraw functions 
;-------------------------------------------------------------------------------------------
; Two possibilities of access to the ddraw functions
; Example:
;
;    push DDSCL_EXCLUSIVE+DDSCL_FULLSCREEN
;    push [hWin]
;    mov eax,[DDraw]
;    push eax
;    mov eax,[eax]
;    call [eax+DD_SetCooperativeLevel]
;
; or with macro:
;
;    dd_setcooperativelevel([DDraw],[hWin],DDSCL_EXCLUSIVE+DDSCL_FULLSCREEN)
;
;-------------------------------------------------------------------------------------------

dd_setcooperativelevel(%a,%b,%c) = \
   push %c,%b                      \
   mov eax,%a                      \
   push eax                        \
   mov eax,[eax]                   \
   call [eax+DD_SetCooperativeLevel]

dd_setdisplaymode(%a,%b,%c,%d) = \
   push %d,%c,%b                 \
   mov eax,%a                    \
   push eax                      \
   mov eax,[eax]                 \
   call [eax+DD_SetDisplayMode]

dd_createsurface(%a,%b,%c,%d) = \
   push %d,%c,%b                \
   mov eax,%a                   \
   push eax                     \
   mov eax,[eax]                \
   call [eax+DD_CreateSurface]

dd_createclipper(%a,%b,%c,%d) = \
   push %d,%c,%b                \
   mov eax,%a                   \
   push eax                     \
   mov eax,[eax]                \
   call [eax+DD_CreateClipper]

dd_createpalette(%a,%b,%c,%d,%e) = \
   push %e,%d,%c,%b                \
   mov eax,%a                      \
   push eax                        \
   mov eax,[eax]                   \
   call [eax+DD_CreatePalette]

dds_getattachedsurface(%a,%b,%c) = \
   push %c,%b                      \
   mov eax,%a                      \
   push eax                        \
   mov eax,[eax]                   \
   call [eax+DDS_GetAttachedSurface]

dds_blt(%a,%b,%c,%d,%e,%f) = \
   push %f,%e,%d,%c,%b       \
   mov eax,%a                \
   push eax                  \
   mov eax,[eax]             \
   call [eax+DDS_Blt]

dds_bltfast(%a,%b,%c,%d,%e,%f) = \
   push %f,%e,%d,%c,%b           \
   mov eax,%a                    \
   push eax                      \
   mov eax,[eax]                 \
   call [eax+DDS_BltFast]

dds_flip(%a,%b,%c) = \
   push %c,%b        \
   mov eax,%a        \
   push eax          \
   mov eax,[eax]     \
   call [eax+DDS_Flip]

dds_islost(%a) = \
   mov eax,%a    \
   push eax      \
   mov eax,[eax] \
   call [eax+DDS_IsLost]

dds_restore(%a) = \
   mov eax,%a     \
   push eax       \
   mov eax,[eax]  \
   call [eax+DDS_Restore]

dds_lock(%a,%b,%c,%d,%e) = \
   push %e,%d,%c,%b        \
   mov eax,%a              \
   push eax                \
   mov eax,[eax]           \
   call [eax+DDS_Lock]

dds_unlock(%a,%b) = \
   push %b          \
   mov eax,%a       \
   push eax         \
   mov eax,[eax]    \
   call [eax+DDS_Unlock]

dds_setclipper(%a,%b) = \
   push %b              \
   mov eax,%a           \
   push eax             \
   mov eax,[eax]        \
   call [eax+DDS_SetClipper]

dds_setpalette(%a,%b) = \
   push %b              \
   mov eax,%a           \
   push eax             \
   mov eax,[eax]        \
   call [eax+DDS_SetPalette]

dds_getdc(%a,%b) = \
   push %b         \
   mov eax,%a      \
   push eax        \
   mov eax,[eax]   \
   call [eax+DDS_GetDC]

dds_releasedc(%a,%b) = \
   push %b             \
   mov eax,%a          \
   push eax            \
   mov eax,[eax]       \
   call [eax+DDS_ReleaseDC]

dds_setcolorkey(%a,%b,%c) = \
   push %c,%b               \
   mov eax,%a               \
   push eax                 \
   mov eax,[eax]            \
   call [eax+DDS_SetColorKey]

dds_release(%a) = \
   mov eax,%a     \
   push eax       \
   mov eax,[eax]  \
   call [eax+DDS_Release]

ddc_release(%a) = \
   mov eax,%a     \
   push eax       \
   mov eax,[eax]  \
   call [eax+DDC_Release]

ddc_sethwnd(%a,%b,%c) = \
   push %c,%b           \
   mov eax,%a           \
   push eax             \
   mov eax,[eax]        \
   call [eax+DDC_SetHWnd]

;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================
